//
//	VidyoMediaFormats_Objc.h
//	VidyoClient
//
//	This file is auto generated, do not edit this file
//	Copyright (c) 2023 Vidyo, Inc. All rights reserved.
//

/*!
 * @enum Represents the media format.
 * @constant VCMediaFormatIN16 
 * @constant VCMediaFormatFL32 
 * @constant VCMediaFormatNULL 
 * @constant VCMediaFormatI420 
 * @constant VCMediaFormatYU12 
 * @constant VCMediaFormatYUYV 
 * @constant VCMediaFormatYUY2 
 * @constant VCMediaFormatyuvs 
 * @constant VCMediaFormat2vuy 
 * @constant VCMediaFormatUYVY 
 * @constant VCMediaFormatHDYC 
 * @constant VCMediaFormatyuv2 
 * @constant VCMediaFormatyuvu 
 * @constant VCMediaFormatNV12 
 * @constant VCMediaFormatNV21 
 * @constant VCMediaFormat24BG 
 * @constant VCMediaFormatraw 
 * @constant VCMediaFormatBGRA 
 * @constant VCMediaFormatRGBA 
 * @constant VCMediaFormatARGB 
 * @constant VCMediaFormatBYR1 
 * @constant VCMediaFormatBYR2 
 * @constant VCMediaFormatJPEG 
 * @constant VCMediaFormatMJPG 
 * @constant VCMediaFormatdmb1 
 * @constant VCMediaFormatavc1 
 * @constant VCMediaFormathvc1 
 * @constant VCMediaFormatM420 
 * @constant VCMediaFormat420f 
 * @constant VCMediaFormat420v 
 * @constant VCMediaFormatY8 
 */
typedef NS_ENUM(NSInteger, VCMediaFormat) {
	VCMediaFormatIN16,
	VCMediaFormatFL32,
	VCMediaFormatNULL,
	VCMediaFormatI420,
	VCMediaFormatYU12,
	VCMediaFormatYUYV,
	VCMediaFormatYUY2,
	VCMediaFormatyuvs,
	VCMediaFormat2vuy,
	VCMediaFormatUYVY,
	VCMediaFormatHDYC,
	VCMediaFormatyuv2,
	VCMediaFormatyuvu,
	VCMediaFormatNV12,
	VCMediaFormatNV21,
	VCMediaFormat24BG,
	VCMediaFormatraw,
	VCMediaFormatBGRA,
	VCMediaFormatRGBA,
	VCMediaFormatARGB,
	VCMediaFormatBYR1,
	VCMediaFormatBYR2,
	VCMediaFormatJPEG,
	VCMediaFormatMJPG,
	VCMediaFormatdmb1,
	VCMediaFormatavc1,
	VCMediaFormathvc1,
	VCMediaFormatM420,
	VCMediaFormat420f,
	VCMediaFormat420v,
	VCMediaFormatY8
};
/*!
 * Describes a plane of a video frame.
 */
@interface VCVideoPlane : NSObject
{
}
	/*!
	 * pointer to the plane buffer.
	 */
	@property unsigned char* buffer;
	/*!
	 * The number of pitch sized rows in the plane buffer.
	 */
	@property size_t height;
	/*!
	 * The number of bytes of padding before any rows of the image.
	 */
	@property size_t offset;
	/*!
	 * The number of bytes in each row of the plane buffer.
	 */
	@property size_t pitch;
	/*!
	 * The size in bytes of the buffer.
	 */
	@property size_t size;
	/*!
	 * The width in pixels of the plane.
	 */
	@property size_t width;
@end
